# button class


import pygame
from pygame.locals import *

import tools, parameters

class Font:
    def __init__(self, type, pos, size, text, color = 0):
        self.text, self.rect = tools.get_font(type, size, text, color)
        self.rect.center = pos

    def draw(self):
        tools.background.blit(self.text, self.rect)

    def remove(self):
        tmp_img, tmp_rect = tools.get_solid(self.rect.size, parameters.BACKGROUND_COLOR)
        tools.background.blit(tmp_img, self.rect)

class Button:

    action = None
    texty = None
    def __init__(self, pos,  text, color = 0):
        self.texty = text
        
        padding = (10,6)
        if color == 0: color = (255, 255, 255)

        if text != '':
             self.text, self.rect = \
                         tools.get_font(None, parameters.BUTTON_SIZE, text, parameters.BUTTON_TEXT_COLOR)

        # inflate rect
        tmp_rect = Rect(self.rect)
        tmp_rect.inflate_ip(padding)
        
        self.image, self.rect = tools.get_solid(tmp_rect.size, color)

        tmp_rect = Rect(self.rect)
        tmp_rect.inflate_ip(-4,-4)

        tmp, tmp_rect = tools.get_solid(tmp_rect.size, parameters.BACKGROUND_COLOR)

        self.image.blit(tmp, (2,2))

        self.image.blit(self.text, (padding[0]/2, padding[1]/2))
        
        self.rect.center = pos

    def draw(self):
        tools.background.blit(self.image, self.rect)

    def check_clicked(self, pos):
        if self.rect.collidepoint(pos):
            self.action[0](self.action[1])
           

        
