
# Sensor class

import pygame
from pygame.locals import *

import tools

class Sensor(pygame.sprite.Sprite):
    """Sensor class"""

    SENSOR_RECT = Rect(600,200,80,40)
    COLOR = (50,50,50)
    
    def __init__(self):
        
        pygame.sprite.Sprite.__init__(self)

        self.image, self.rect = tools.get_solid(self.SENSOR_RECT.size, self.COLOR)

        self.rect.topleft = self.SENSOR_RECT.topleft

        self.original = self.image

        self.direction = 0

    def rotate(self, delta_deg):
        center = self.rect.center

        self.direction = (self.direction + delta_deg) % 16
        
        self.image = pygame.transform.rotate(self.original, self.direction * 22.5)

        self.rect = self.image.get_rect()
        self.rect.center = center
