#!/usr/env/python

import pygame
from pygame.locals import *


# game imports
import Vehicle, Wall, Lamp, Debug_pt

WINDOW_SIZE = (800,600)

BACKGROUND_COLOR = (10, 10, 10) # off black

def main():

    screen = pygame.display.set_mode(WINDOW_SIZE)
    pygame.display.set_caption('BV')

    background = pygame.Surface(screen.get_size())
    background = background.convert()
    background.fill(BACKGROUND_COLOR)

    screen.blit(background, (0, 0))
    pygame.display.flip()

    # Objects
    clock = pygame.time.Clock()

    vehicle = Vehicle.Vehicle()

    dp_a = Debug_pt.Debug_pt((0,0,2,2), (0,255,0))
    dp_b = Debug_pt.Debug_pt((0,0,2,2), (0,255,0))
    dp_c = Debug_pt.Debug_pt((0,0,2,2), (0,255,0))
    #wall = Wall.Wall((100,100,50,50), (0,0,255))
    lamp = Lamp.Lamp((400,200,10,10), (255,0,0))
    
    sprites = pygame.sprite.RenderPlain((vehicle,lamp, dp_a, dp_b, dp_c))

    while 1:
        clock.tick(60)

        screen.blit(background, (0, 0))
        sprites.draw(screen)
        pygame.display.flip()

        for event in pygame.event.get():
            if event.type == QUIT:
                return
            elif event.type == KEYDOWN:
                if event.key == K_LEFT:
                    vehicle.turn_left()
                elif event.key == K_RIGHT:
                    vehicle.turn_right()

        lamps = (lamp,)
        (dp_a.newpos, dp_b.newpos, dp_c.newpos) = vehicle.chk_prox(lamps)
        
        sprites.update()
                

        


if __name__ == '__main__': main()
