# global useful functions

import os,math

import pygame
from pygame.locals import *

import parameters, levels

# global vars
screen = None
background = None

current_screen = None
next_level = 0
title_screen = None

change_level = 0

level_counter = 0

group = None



def load_image(gfx_name, colorkey = None):
    filename = os.path.join(parameters.gfx_dir, gfx_name)

    try:
        image = pygame.image.load(filename)
    except pygame.error, message:
        print 'Error cannot load image: '+filename
        raise SystemExit, message

    image = image.convert()

    if colorkey != None:
        colorkey = image.get_at(colorkey)
        image.set_colorkey(colorkey, RLEACCEL)

    return image, image.get_rect()

def get_solid(size, color):
    image = pygame.Surface(size)
    image.fill(color)

    return image, image.get_rect()
    
def get_font(type, size, text, color=0):
    if color == 0: color = (255, 255, 255)
    
    font = pygame.font.Font(type, size)
    text = font.render(text, 1, color)
    return text, text.get_rect()

def get_x_y(dir, vel):
    # Not much brain use here (:
    if dir == 0:
        return -vel, 0
    elif dir == 1:
        return -vel, 1
    elif dir == 2:
        return -2, 2
    elif dir == 3:
        return -1, vel
    elif dir == 4:
        return 0, vel
    elif dir == 5:
        return 1, vel
    elif dir == 6:
        return 2, 2
    elif dir == 7:
        return vel, 1
    elif dir == 8:
        return vel, 0
    elif dir == 9:
        return vel, -1
    elif dir == 10:
        return 2, -2
    elif dir == 11:
        return 1, -vel
    elif dir == 12:
        return 0, -vel
    elif dir == 13:
        return -1, -vel
    elif dir == 14:
        return -2, -2
    elif dir == 15:
        return -vel, -1
    

#returns distance between 2 points
def mag(a, b):
    return int(math.sqrt((a[0]-b[0])*(a[0]-b[0]) + (a[1]-b[1])*(a[1]-b[1])))

def sq(x):
    return x*x

def norm(x):
    return math.sqrt(x[0]*x[0] + x[1]*x[1])

def dot(x, y):
    return x[0]*y[0] + x[1]*y[1]


def vec_add(x, y):
    return (x[0]+y[0], x[1]+y[1])

def vec_sub(x, y):
    return (x[0]-y[0], x[1]-y[1])

# 2d cross product
def cross(x, y):
    return x[0]*y[1] - x[1]*y[0]

# returns true if point p is in triangle with vectors a, b, c.
def tri_contains(point_a, point_b, point_c, point_p):
    denom = cross(vec_sub(point_a, point_c), vec_sub(point_b, point_c))

    u = cross(vec_sub(point_p, point_c), vec_sub(point_b, point_c))/denom
    v = cross(vec_sub(point_a, point_c), vec_sub(point_p, point_c))/denom

    if u + v < 1.0 and u > 0.0 and v > 0.0:
        return 1
    else:
        return 0
    

def change_level(level):
    global current_screen, next_level
    #print next_level
    if level == 'level':
        current_screen = levels.get_level(next_level)
    else:
        current_screen = level


def get_title_screen():
    global title_screen
    return title_screen


def start_veh(veh):
    veh.state = 'drive'

def reset(level):
    level.reset()
    
